
#include	"js_simple.h"

/* Copyright (c) 2008 James Dow Allen.  All Rights Reserved; see License.
 * Subroutines useful for generating
 * reversible hash functions.
 */

int isprime(Uint32 x)
{
	Uint32 y, z;

	if (x % 2 == 0)
		return x == 2;
	for (y = 3; z = x / y, z >= y; y += 2)
		if (x == z * y)
			return 0;
	return 1;
}

/* Find the first odd prime larger than x */
Uint32 nxtprime(Uint32 x)
{
	Uint	xx = x % 6;
	Uint32	tx = x - xx + 1;

	if (x < 7)
		return x < 3 ? 3 : x < 5 ? 5 : 7;
	/* Next is a bit like Duff's Famous Device */
	else switch (xx) {
	case 0:
		while (1) {
			if (isprime(tx))
				return tx;
		/* FALLTHRU */
	case 1: case 2: case 3: case 4:
			if (isprime(tx + 4))
				return tx + 4;
		/* FALLTHRU */
	case 5:
			tx += 6;
		}
	}
	/* NOTREACHED */
	return 0; /* but suppress warning message anyway */
}

