
/*
 * Kahan's method of addition is often overlooked; and
 *  then severe loss of precision can result.
 * The code here provides a demonstration of its efficacy.
 *
 * Of course you'd want to use doubles (or even long long doubles)
 *  but we allow floats to demonstrate the efficacy more easily.
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>

#ifdef	FLOAT
typedef	float Real;
#else
typedef	double Real;
#endif

struct KahanAdder {
	Real	ka_sum, ka_carry;
};

/* *kp = 0 */
void kahan_clear(struct KahanAdder *kp);

/* *kp += addend */
Real kahan_add(struct KahanAdder *kp, Real addend);

