
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>

/*
 * y' = Phi(1.64 * Phi^-1 (y))
 */
double	LR_PARAM = 1.64;

long double	Pco;

long double phi(long double x)
{
	return Pco * expl(-x * x / 2);
}

#define	GPERU	1000

int main(int argc, char **argv)
{
	long double	x, xp, cum_xp;
	double		y, save_x = 0;

	setlinebuf(stdout);
	if (argc > 2 && !strcmp(argv[1], "-P")) {
		LR_PARAM = atof(argv[2]);
		argv += 2;
	}
	if (argv[1] == 0) {
		printf("Usage: roths_adjust [-P #P] prob\n");
		printf("  Adjust a market probability, using parameter 1.64 or #P\n");
		exit(1);
	}

	y = atof(argv[1]);
	Pco = 1 / sqrt(2*3.14159265359);
	cum_xp = 0;
	for (x = -6; x < 6; x += 1.0 / GPERU) {
		xp = phi(x);
		cum_xp += xp / GPERU;
		if (cum_xp > y) {
			save_x = LR_PARAM * (x - 0.5 / GPERU);
			if (0) printf("Cum_xp = %f x = %f\n",
				cum_xp, x);
			break;
		}
		if (0) printf(" %f : %f : %f\n",
			(double)x, (double)xp, (double)cum_xp);
	}
	cum_xp = 0;
	for (x = -6; x < 6; x += 1.0 / GPERU) {
		xp = phi(x);
		cum_xp += xp / GPERU;
		if (x > save_x) {
			cum_xp -= 0.5 * xp / GPERU;
			printf("%f --> %f\n",
				y, (double)cum_xp);
			break;
		}
	}
	exit(0);
}
