
#include	<stdio.h>
#include	<stdlib.h>
#include	<strings.h>
#include	<math.h>

struct place {
	char	*city, *country;
	double	ladeg, lodeg;
	int	population;
} Place[] = {
#include	"cities.h"
};

#define	NUMEL(arr)	(sizeof (arr) / sizeof *(arr))
#define	NUMPLACE	NUMEL(Place)

/*
 * This program is based on one by david.williams at ablelink.org
 * Translated from Basic to C by jda, who also eliminated
 * some frills.
 */
#define	J_PI  3.1415926535898

double	deg2rad(double deg)
{
	return deg * J_PI / 180;
}

/* We use only an average Earth radius for calculations */
double Radnet = 6371;	/* Earth radius in km */
/*
 * double Radpolar = 6356.9;
 * double Radequat = 6378.5;
 */

/* Calculate distance between long1, lati1, long2, lati2 */
double getdist(double long1, double lati1, double long2, double lati2)
{
	double	lg, y, t, x, z, r, a2;

	lg = long2 - long1;
	y = sin(lati1);
	t = cos(lati1);
	x = t * sin(lg);
	z = t * cos(lg);
	r = sqrt(y*y + z*z);
	a2 = cos(atan2(y, z) - lati2);
	y = - r * a2;
	return Radnet * (J_PI / 2 + atan2(y, sqrt(1 - y*y)));
}

int main(int argc, char **argv)
{
	unsigned int	ix1, ix2, bestix = 0;
	double		long1, lati1, long2, lati2;
	double		maxdi, tdis;

	setlinebuf(stdout);
	/* Convert the degrees in header-file to radians */
	for (ix1 = 0; ix1 < NUMPLACE; ix1++) {
		Place[ix1].lodeg = deg2rad(Place[ix1].lodeg);
		Place[ix1].ladeg = deg2rad(Place[ix1].ladeg);
	}
	for (ix1 = 0; ix1 < NUMPLACE; ix1++) {
		maxdi = 0;
		long1 = Place[ix1].lodeg;
		lati1 = Place[ix1].ladeg;
		for (ix2 = 0; ix2 < NUMPLACE; ix2++)
		if (ix1 != ix2) {
			long2 = Place[ix2].lodeg;
			lati2 = Place[ix2].ladeg;
			tdis = getdist(long1, lati1, long2, lati2);
			if (tdis > maxdi) {
				maxdi = tdis;
				bestix = ix2;
			}
		}
		ix2 = bestix;
		printf(" %8.1f is Distance from %s (%s) to %s (%s)\n",
				maxdi,
				Place[ix1].city, Place[ix1].country,
				Place[ix2].city, Place[ix2].country);
	}
	exit(0);
}
