
/*
 * Count the hands with s0-s1-s2-s3 shape
 * and hc points total
 */
#include	<stdio.h>
#include	<stdlib.h>

/* Use the Pascal's Triangle from gencombo.c &/
#define	Size_Triangle(n)	((((n)+2)*((n)+1))/2)
long PT[Size_Triangle(13)];
#define	Choose(n, m)	(PT[(m) + Size_Triangle(n-1)])

void mk_pasc_tri(unsigned short maxn, long *pasctri);

int csub(int numc)
{
	return
		numc < 0 ? 0 :
		numc > 9 ? 0 :
		numc < 1 ? 1 :
		Choose(9, numc);
}

int cnth(int numc, int hc)
{
	switch (hc) {
	case 0:
		return csub(numc);
	case 1:
		return csub(numc - 1);
	case 2:
		return csub(numc - 1);
	case 3:
		return csub(numc - 1) + csub(numc - 2);
	case 4:
		return csub(numc - 1) + csub(numc - 2);
	case 5:
		return csub(numc - 2) + csub(numc - 2);
	case 6:
		return csub(numc - 2) + csub(numc - 3);
	case 7:
		return csub(numc - 2) + csub(numc - 3);
	case 8:
		return csub(numc - 3);
	case 9:
		return csub(numc - 3);
	case 10:
		return csub(numc - 4);
	default:
		return 0;
	}
}

int main(int argc, char **argv)
{
	int	totcard, hc, i, s[4], h[4];
	long long tcnt, totcnt;
	int	hc0 = -1;

	mk_pasc_tri(13, PT);
	if (argc == 7) {
		hc0 = atoi(argv[6]);
	} else if (argc != 6) {
		printf("Usage: bridgcnt #s0 #s1 #s2 #s3 #hcp [#hc0]\n");
		printf(" to show the number of hands with s0-s1-s2-s3 pattern and hcp HCP.\n");
		printf(" The optional hc0 parameter fixes the number of HCP in first suit.\n");
		exit(64);
	}
	for (totcard = i = 0; i < 4; i++) {
		s[i] = atoi(argv[i + 1]);
		totcard += s[i];
	}
	if (totcard != 13) {
		printf("Shape sums not to 13\n");
		exit(25);
	}
	hc = atoi(argv[5]);

	totcnt = 0;
	for (h[0] = 0; h[0] <= hc; h[0]++)
	for (h[1] = 0; h[0] + h[1] <= hc; h[1]++)
	for (h[2] = 0; h[0] + h[1] + h[2] <= hc; h[2]++) {
		if (hc0 >= 0 & hc0 != h[0])
			break;
		h[3] = hc - h[0] - h[1] - h[2];
		tcnt  = cnth(s[1], h[1]);
		tcnt *= cnth(s[2], h[2]);
		tcnt *= cnth(s[3], h[3]);
		// printf("%d %d %d --> %ld\n", h[1], h[2], h[3], tcnt);
		tcnt *= cnth(s[0], h[0]);
		totcnt += tcnt;
	}
	printf("%lld\n", totcnt);
	exit(0);
}
