

/* How many ways are there to place K red beads on an
 * oriented necklace of N total beads,
 * such that there are at least G
 * non-red beads between each pair of red beads?
 *
 * If N is prime, dividing the printed result by N
 * will give you the number of such UNoriented necklaces.
 */
#include	<stdio.h>
#include	<stdlib.h>

int	Numbead; /* N */
int	Numred;  /* K */
int	Mingap;  /* G */

unsigned long long bincoeff(int nn, int mm);

long cntneck(int sofar, int opos, int numleft)
{
	long	tot;
	int	pos;
	long long j, sj;

	j = (long long)1 << opos + Mingap;
	j |= j - 1;
	sj = sofar;
	sj <<= Numbead;
	if (numleft == 0) {
		tot = 1;
	} else for (tot = 0, pos = opos;
			pos < Numbead && ! (j & sj);
			j <<= 1, pos++) {
		tot += cntneck(sofar | 1 << pos,
				pos + Mingap + 1,
				numleft - 1);
	}
	return tot;
}

int main(int argc, char **argv)
{
	int	res;

	if (argc != 4) {
	usage:
		printf("Usage: cnt_neck #Totalbead #Numred #Mingap\n");
	lessthan:
		printf("   Totalbead mus be less than 30\n");
		exit(1);
	}
	Numbead = atoi(argv[1]);
	if (Numbead >= 30)
		goto lessthan;
	Numred = atoi(argv[2]);
	Mingap = atoi(argv[3]);
	res = cntneck(0, 0, Numred);
	printf("There are %ld compliant necklaces\n", res);
	printf("Chance that a random (%d,%d) necklace is compliant = %10.7f\n",
			Numbead, Numred,
			res / (double)bincoeff(Numbead, Numred));
	exit(0);
}

unsigned long long bincoeff(int nn, int mm)
{
	int		k;
	unsigned long long	answer = 1;

	if (mm + mm > nn)
		mm = nn - mm;
	for (k = 0; k < mm; k++) {
		answer *= (nn - k);
		answer /= (1 + k);
	}
	return answer;
}
