
/*
 * Trivial, good-enough, hash routine
 *
 * Although trivial, it offers some uncommon features!
 *  * Quadratic reprobe, decaying to linear.
 *  * NUMHCAB for poor man's quotienting.
 * Make NUMHCAB uniformly 1 is simplest, unless the
 *   resultant key % NUMEL is too big to fit in the
 *   hastable's key field.
 */

struct hashe *findnode(unsigned long long key)
{
	int	htix, ix, incr;
	struct hashe *np;

	htix = key % NUMHCAB;
	key = 1 + key / NUMHCAB;
	ix = key % NUMEL;
	incr = -1;
	while (1) {
		np = Hashe[htix] + ix;
		if (HT_EMPTY(np) || HT_MATCH(np, key))
			return np;
		ix += incr ? (incr += 2) : 2;
		while (ix >= NUMEL) {
			ix -= NUMEL;
			if (incr >= NUMEL - 4)
				incr = 0;
		}
	}
}
