
#include	<stdio.h>
#include	<stdlib.h>
#include	"j_random.h"

#define	STARTBANK	100
#define	NUMROUNDS	10
#define	BA_SIZE		3500

double	Probgoal[BA_SIZE][NUMROUNDS][8];
int	Bestbet [BA_SIZE][NUMROUNDS][8];
int	Target, Thisbet;

double	Di_ch[] = {
	 1/36.0,  2/36.0,  3/36.0,  4/36.0,  5/36.0,  6/36.0,
	 5/36.0,  4/36.0,  3/36.0,  2/36.0,  1/36.0,
};

double	getex(int bank, int round, int tobeat)
{
	double	sco, bestsco;
	int	bet, bstbet, nroll;

	Thisbet = bstbet = 0;
	if (bank >= Target) {
		Thisbet = bank - Target;
		return 1;
	} else if (round == NUMROUNDS || bank == 0) {
		return 0;
	} else if ((bestsco = Probgoal[bank][round][tobeat]) >= 0) {
		Thisbet = Bestbet[bank][round][tobeat];
		return bestsco;
	} else if (0
			|| round == NUMROUNDS - 1 && bank * 2 < Target
			|| round == NUMROUNDS - 2 && bank * 4 < Target
			|| round == NUMROUNDS - 3 && bank * 8 < Target) {
		bstbet = bank;
		bestsco = 0;
	} else for (bestsco = -2, bet = 0;
				bet <= bank && bet + bank <= Target;
				bet++) {
		sco = 0;
		for (nroll = 2; nroll < 13; nroll++) {
			sco += Di_ch[nroll - 2] * getex(nroll < tobeat
					? bank - bet : nroll == tobeat
					? bank : bank + bet,
				round + 1,
				nroll < 8 ? nroll : 14 - nroll);
		}
		/* We modify the equality test for determinism */
		if (sco >= bestsco - 0.0000000000001) {
			bestsco = sco;
			bstbet = bet;
		}
	}
	Thisbet = Bestbet[bank][round][tobeat] = bstbet;
	return Probgoal[bank][round][tobeat] = bestsco;
}

int rshake(void)
{
	return 2 + rand_index(6) + rand_index(6);
}
	
int sim(int bank)
{
	int	roll, nroll, round, bet;

	nroll = rshake();
	for (round = 0; bank && round < 10; round++) {
		roll = nroll > 7 ? 14 - nroll : nroll;
		getex(bank, round, roll);
		nroll = rshake();
		if (0)
	printf("In round %d with bank %d betting %d to beat %d; rolled %d\n",
				round, bank, Thisbet, roll, nroll);
		if (nroll > roll)
			bank += Thisbet;
		else if (nroll < roll)
			bank -= Thisbet;
	}
	return bank;
}

int main(int argc, char **argv)
{
	int	i, round, tobeat, bank;
	double	t, netchance;

	Target = atoi(argv[1]);
	for (round = NUMROUNDS - 1; round >= 0; round--)
	for (tobeat = 2; tobeat <= 7; tobeat++)
	for (bank = 0; bank < BA_SIZE; bank++) {
		Probgoal[bank][round][tobeat] = -1;
	}

	netchance = 0;
	for (tobeat = 2; tobeat <= 7; tobeat++) {
		t = getex(STARTBANK, 0, tobeat);
		printf("Starting with %d, chance = %f\n",
				tobeat, t);
		printf("Best bet = %d\n",
			Bestbet[STARTBANK][0][tobeat]);
		netchance += Di_ch[tobeat - 2] * t * (tobeat == 7 ? 1 : 2);
	}
	printf("Net = %f\n", netchance);
	for (i = 0; i < 1000000; i++)
		printf("%d\n", sim(STARTBANK));
	exit(0);
}
