
#include	"kahan.h"

int     Leng = 2220000;	/* Arbitrary */

int main(int argc, char **argv)
{
	int	x;
	Real	t, ord_sum;
	struct KahanAdder Sum;

	/* Calculating Euler's constant */
	kahan_clear(&Sum);
	kahan_add(&Sum, -log(Leng));
	ord_sum = -log(Leng);

	for (x = 1; x < Leng; x++) {
		t = 1.0 / x;
		kahan_add(&Sum, t);
		ord_sum += t;
	}

	printf("Eulers_g = %14.13f\n",
		0.57721566490153286060651209008240243104215933593);

	printf("Ordinary = %14.13f\n", ord_sum);
	printf("Kahanadd = %14.13f\n", Sum.ka_sum);

	/* Calculating Archimedes' constant */
	kahan_clear(&Sum);
	ord_sum = 0;
	for (x = 1; x < Leng; x++) {
		t = 1.0 / x / x;
		kahan_add(&Sum, t);
		ord_sum += t;
	}
	printf("Ordinary = %14.13f\n", sqrt(6*ord_sum));
	printf("Kahanadd = %14.13f\n", sqrt(6*Sum.ka_sum));

	exit(0);
}



