
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	"j_random.h"

int	Num_gly;
#define	MAX_GLY	300000

struct walkerent Walker[MAX_GLY][256];

/* Define next for more efficient use of random() */
#ifdef  RAN_EFFIC
#define RAN_EFFIC

#define SETWALKER       rand_esetwalker
#define WALKER          rand_ewalker

#else

#define SETWALKER       rand_setwalker
#define WALKER          rand_walker
#endif

unsigned char	buff[5000030];
#define	OSIZE	120000

int	Glylen;

int gly2ix(int *tc, int makeit);

int main(int argc, char **argv)
{
	int	siz, i, j, ix;
	int	tc[12];

	if (argv[1])
		Glylen = atoi(argv[1]);
	if (9 < Glylen || Glylen < 1)
		Glylen = 4;
	siz = fread(buff, 1, 5000000, stdin);

	for (j = 0; j < 20; j++)
		buff[siz + j] = buff[j];

	for (j = 1; j < Glylen; j++)
		tc[j] = buff[j - 1];
	for (i = 0; i < siz; i++) {
		for (j = 0; j < Glylen - 1; j++)
			tc[j] = tc[j + 1];
		tc[j] = buff[i + Glylen - 1];
		ix = gly2ix(tc, 1);
		Walker[ix - 1][tc[j]].prob1 += 1.0;
	}

	fprintf(stderr, "Num_gly = %d\n", Num_gly);

	for (ix = 0; ix < Num_gly; ix++) {
		for (j = 0; j < 256; j++)
			Walker[ix][j].x1 = j;
		SETWALKER(Walker[ix], 256);
	}

	/* First four characters of input are reused */
	for (j = 1; j < Glylen; j++)
		tc[j] = buff[j - 1];
	for (i = Glylen - 1; i < OSIZE - 1; i++) {
		for (j = 0; j < Glylen - 1; j++)
			tc[j] = tc[j + 1];
		ix = gly2ix(tc, 0);
		tc[j] = buff[i] = WALKER(Walker[ix - 1], 256);
	}
	buff[i] = '\n';
	fwrite(buff, 1, OSIZE, stdout);
	rand_seed(1);
	rand_bits(99);
	exit(0);
}

#define	NUMEL	990001
#define	NUMHCAB	1

struct hashe {
	unsigned long long	keyval;
	int	indx;
} Hashe[NUMHCAB][NUMEL];


#define	HT_EMPTY(np)		((np)->indx == 0)
#define HT_MATCH(np, kkk)	((np)->keyval == (kkk) - 1)

/* The above customizes a particular hash table,
 *  Allowing us to use a small generic source function:
 *
 * struct hashe *findnode(unsigned long long key);
 */

#include	"ezhash.c"

int gly2ix(int *tc, int makeit)
{
	struct hashe *np;
	unsigned long long glyp = 0;
	int	i;

	for (i = 0; i < Glylen - 1; i++)
		glyp = (glyp << 8) | tc[i];

	np = findnode(glyp);
	if (HT_EMPTY(np)) {
		if (!makeit) {
			fprintf(stderr, "No hit on %06x\n", glyp);
			exit(1);
		}
		np->keyval = glyp;
		np->indx = ++Num_gly;
		if (Num_gly > MAX_GLY) {
			fprintf(stderr, "Num_gly exceeds MAX_GLY\n");
			exit(1);
		}
	}
	return np->indx;
}

