
/*
 * Pick four points randomly in a triangle.
 * What is probability they form a convex quadrilateral?
 *
 * Note that, due to affine transforms and their properties,
 *  it matters not what triangle we use!
 *
 * Useless program?  Maybe!  But it has some useful subroutines.
 */

#include	<stdlib.h>
#include	<stdio.h>
#include	"j_random.h"

struct xy { double x, y; } Pt[104], *P;

#define	DIS(a,b,z)	(P[a].z - P[b].z)
#define	NX(a,b,c)	(DIS(a,b,x) * DIS(c,a,y) > DIS(c,a,x) * DIS(a,b,y))

int	Mode;	/* 0 = triangle 1 = square, 2 = circle */
void rp_in_tri(struct xy *p)
{
	double	t;
    loop:
	p->x = rand_unif(0.0, 1.0);
	p->y = rand_unif(0.0, 1.0);
	switch (Mode) {
	case 0:
		if (p->x + p->y > 1) {
			p->x = 1 - p->x;
			p->y = 1 - p->y;
		}
	case 1:
		return;
	case 2:
		t = (p->x - 0.5) * (p->x - 0.5);
		t += (p->y - 0.5) * (p->y - 0.5);
		if (t > 0.25)
			goto loop;
		return;
	}
}

int is_cvx_quad(void)
{
	return 1 ^ NX(0,1,2) ^ NX(1,2,3) ^ NX(2,3,0) ^ NX(3,0,1);
}

int main(int argc, char **argv)
{
	int	i, j, numcvx;

	if (argv[1]) {
		Mode = argv[1][0] == 'C' ? 2 : 1;
	}
	for (numcvx = i = 0; i < 1000 * 1000; i += 1) {
		for (j = 0; j < 104; j++)
			rp_in_tri(Pt + j);
		for (j = 0; j < 100; j++) {
			P = Pt + j;
			if (is_cvx_quad())
				numcvx += 1;
		}
	}
	printf("%f\n", numcvx / (100.0 * i));
	exit(0);
}
