
/*
 * timelimit.c  --  Run a Unix command with a time limit
 * Copyright (c) 2006 by James Dow Allen
 *
 *  This program can be distributed or modified subject to
 *  the terms of the GNU General Public License (version 2
 *  or, at your option, any later version) as published by
 *  the Free Software Foundation.
 *
 * This is an old program which might be slightly incompatible with cygwin.
 *	(It works, but gets compiler warnings.)
 */

#define EXIT_GOOD       0
#define EXIT_EXPECT     4       /* "intended" error */
#define EXIT_BADFILE    6       /* missing file, etc. */
#define EXIT_USAGE      64      /* command line usage error */

#include	<stdlib.h>
#include	<stdio.h>
#include	<signal.h>

int	Child;

void doalarm() 
{
	kill(Child, SIGTERM);
	printf("Time limit exceeded.\n");
	exit(EXIT_EXPECT);
}

struct sigaction Alarm = {
	doalarm, 0, 0, 0,
};

int main(int argc, char **argv) 
{

	if (argc < 3) {
		printf("Usage: timelimit #secs command ... \n");
		exit(EXIT_USAGE);
	}
	if (Child = fork()) {
		sigaction(SIGALRM, &Alarm, (struct sigaction *)0);
		alarm(atoi(argv[1]));
		waitpid(Child, (int *)0, 0);
		exit(EXIT_GOOD);
	} else {
		argv += 2;
		execvp(*argv, argv);
		perror(*argv);
		exit(EXIT_BADFILE);
	}
}
