
/* Copyright 2018 by James Dow Allen */

unsigned long long canon_sig(int siz, int *bmat);

#include	<stdlib.h>
#include	<stdio.h>

/* subroutine to get next permutation in a certain order. */
static int next_perm(char *php)
{
	int	nn, i, ix;

	nn = *php;
	if (nn > -2) {
		if (nn < 2 || nn > 62)
			return 0;
		*php++ = -nn;
		i = nn - 1;
		ix = 1 << 8;
		php[0] = 1;
	} else if (nn < -62) {
		return 0;
	} else {
		for (i = 1; php[i] >= i; ) {
			if (++i == -nn)
				return 0;
		}
		ix = (i & 1 ? php[i] : 0) | i << 8;
		php[i] += 1;
	}
	while (i > 1)
		php[--i] = 0;
	return ix;
}

#define	MAXSIZE	12
static char	Permhelp[MAXSIZE];
static char	Permutat[MAXSIZE];

static void perm_mval(int ixa, int ixb, int siz, int *bmat)
{
	int	j, msk, t, tm;

	msk = (1 << siz-1-ixa) | (1 << siz-1-ixb);
	for (j = 0; j < siz; j++) {
		t = bmat[j];
		tm = t & msk;
		if (tm && !(tm-1 & tm)) {
			bmat[j] = t ^ msk;
		}
	}
	t = bmat[ixa];
	bmat[ixa] = bmat[ixb];
	bmat[ixb] = t;
}

static unsigned long long mval(int *mx, int siz)
{
	unsigned long long res;
	int	i, ts, cnt;

	res = 0;
	for (i = 0; i < siz - 1; i++) {
		res |= mx[i] & (1 << siz - 1 - i) - 1;
		res <<= siz - 2 - i;
	}
	return res;
}

/* Find the canonical form of a bit matrix */
unsigned long long canon_sig(int siz, int *bmat)
{
	int	ixa, ixb, j, t;
	unsigned long long tt, signat = 0;

	Permhelp[0] = siz;
	for (j = 0; j < siz; j++)
		Permutat[j] = j + 1;
	while (1) {
		tt = mval(bmat, siz);
		if (0)
			printf("Tt = %013llx\n", tt);
		if (tt > signat)
			signat = tt;
		ixa = next_perm(Permhelp);
		if (ixa == 0) {
			return signat;
		}
		ixb = ixa & 255;
		ixa >>= 8;
		t = Permutat[ixa];
		Permutat[ixa] = Permutat[ixb];
		Permutat[ixb] = t;
		perm_mval(ixa, ixb, siz, bmat);
	}
}
