
#include	<stdlib.h>
#include	<stdio.h>
#include	<math.h>
#include	"matrix.h"

#define	TSIZE	8

double	transf[TSIZE][TSIZE];
double	itransf[TSIZE][TSIZE];
double	fast8[TSIZE][TSIZE];
static double	covar[TSIZE][TSIZE];
static double	eigvals[TSIZE];

int main(int argc, char *argv[])
{
	int	i, j;
	double	RR = 0.002;

	/* First set up the covariance matrix */
	for (i = 0; i < TSIZE; i++) {
		covar[i][i] = 1;
		for (j = i+1; j < TSIZE; j++) {
			covar[i][j] = covar[j][i]
				= 1 - RR*(j-i);
		}
	}

	/* Now calculate the eigensystem */
	make_eigen(covar[0], transf[0], eigvals, TSIZE);
	/* And don't forget the inverse */
	transpose(transf[0], itransf[0], TSIZE, TSIZE);

	aprint("covar", covar[0], TSIZE, TSIZE);
	aprint("transf", transf[0], TSIZE, TSIZE);
	for (i = 0; i < TSIZE; i++)
		printf("%f ", eigvals[i]);
	printf("\n");
}

