
/*
 * NB: The kahan_add() function must be compiled
 *  WITHOUT optimization.
 */
#include	"kahan.h"

void kahan_clear(struct KahanAdder *kp)
{
	kp->ka_carry = kp->ka_sum = 0;
}

Real kahan_add(struct KahanAdder *kp, Real addend)
{
	Real	tmp, y;

	y = addend - kp->ka_carry;
	tmp = kp->ka_sum + y;
	/*
	 * A good Optimizer will rewrite next as
	 *	kp->ka_carry = 0;
	 * Therefore this function must be compiled with optimizaiton OFF.
	 */
	kp->ka_carry = (tmp - kp->ka_sum) - y;
	return kp->ka_sum = tmp;
}
