
#include	<stdlib.h>
#include	<stdio.h>
#include	<math.h>
#include	<string.h>
#include	"kahan.h"

struct KahanAdder Mome1, Mome2, Mome3, Mome4;

int main(int argc, char **argv)
{
	double	x, xx;
	double	fcnt;
	double		mean, stddev, skew, kurt;

	double	mom1 = 0, mom2 = 0, mom3 = 0, mom4 = 0;
	long int	cnt = 3;
	double	min = 9999999999;
	double	max;

	while (--cnt) {
		min *= min * min;
	}
	max = -min;
	while (1 == scanf("%lf", &x)) {
		cnt += 1;
		xx = x * x;
		mom1 = kahan_add(&Mome1, x);
		mom2 = kahan_add(&Mome2, xx);
		mom3 = kahan_add(&Mome3, x*xx);
		mom4 = kahan_add(&Mome4, xx*xx);
		if (x < min) min = x;
		if (x > max) max = x;
	}
	fcnt = cnt;
	mean = mom1 / fcnt;
	stddev = sqrt((mom2*fcnt - mom1*mom1)) / fcnt;
	if (0) printf("%13.8g %13.8g %3.8g %3.8g %3.8g\n",
		mom4/(fcnt),
		- 4*mom3*mean/(fcnt),
		6*mom2*mean*mean/(fcnt),
		- 4*mom1*mean*mean*mean/fcnt,
		mean*mean*mean*mean);
	skew = mom3/fcnt - 3*mom2*mean/fcnt + 3*mom1*mean*mean/fcnt - mean*mean*mean;
	skew /= stddev * stddev * stddev;
	kurt = mom4/(fcnt)
			- 4*mom3*mean/(fcnt)
			+ 6*mom2*mean*mean/(fcnt)
			- 4*mom1*mean*mean*mean/fcnt
			+ mean*mean*mean*mean;
	kurt /= stddev * stddev * stddev * stddev;
	printf(
"    %17.11g mean %17.11g sd  %17.11g skew   %ld items\n    %17.11g kurt %17.11g min %17.11g max\n",
			mean, stddev, skew, cnt, kurt, min, max);
	exit(0);
}
